Loading...
Searching...
No Matches
ReferenceMap< K, T, R, CR > Class Template Reference
Concepts » Map Concepts

## Detailed Description

template<typename K, typename T, typename R, typename CR>
class lemon::concepts::ReferenceMap< K, T, R, CR >

Dereferable map concept.

`#include <lemon/concepts/maps.h>`

Inheritance diagram for ReferenceMap< K, T, R, CR >:
[legend]

## Public Types

typedef True | ReferenceMapTag
| Tag for reference maps.
typedef K | Key
| The key type of the map.
typedef T | Value
| The value type of the map. (The type of objects associated with the keys).
typedef R | Reference
| The reference type of the map.
typedef CR | ConstReference
| The const reference type of the map.
Public Types inherited from ReadWriteMap< K, T >
typedef K | Key
| The key type of the map.
typedef T | Value
| The value type of the map. (The type of objects associated with the keys).
Public Types inherited from ReadMap< K, T >
typedef K | Key
| The key type of the map.
typedef T | Value
| The value type of the map. (The type of objects associated with the keys).
Public Types inherited from WriteMap< K, T >
typedef K | Key
| The key type of the map.
typedef T | Value
| The value type of the map. (The type of objects associated with the keys).

## Public Member Functions

Reference | operator[] (const Key &)
| Returns a reference to the value associated with the given key.
ConstReference | operator[] (const Key &) const
| Returns a const reference to the value associated with the given key.
void | set (const Key &k, const Value &t)
| Sets the value associated with the given key.
Public Member Functions inherited from ReadWriteMap< K, T >
Value | operator[] (const Key &) const
| Returns the value associated with the given key.
void | set (const Key &, const Value &)
| Sets the value associated with the given key.
Public Member Functions inherited from ReadMap< K, T >
Value | operator[] (const Key &) const
| Returns the value associated with the given key.
Public Member Functions inherited from WriteMap< K, T >
void | set (const Key &, const Value &)
| Sets the value associated with the given key.
| WriteMap ()
| Default constructor.